<?php
/*
	 /'\_/`\                                    
	/\      \     __      ___      __     ___   
	\ \ \__\ \  /'__`\  /' _ `\  /'_ `\  / __`\ 
	 \ \ \_/\ \/\ \L\.\_/\ \/\ \/\ \L\ \/\ \L\ \
	  \ \_\\ \_\ \__/.\_\ \_\ \_\ \____ \ \____/
	   \/_/ \/_/\/__/\/_/\/_/\/_/\/___L\ \/___/ 
	                               /\____/      
	                               \_/__/       
	@author Leon Hartley
*/

class Register extends Controller {
	public function __construct() {
		parent::__construct();
	}

	public function base() {

		if(Session::isAuthed()) { Router::sendTo('me'); }

		$this->load_view("register/start");


		if(isset($_SESSION['error'])) {
			$this->view->data->error = $_SESSION['error'];

			unset($_SESSION['error']);
		}

		$this->view->publish();
	}

	public function step2() {
		if(Session::isAuthed()) { Router::sendTo('me'); }

		if(!isset($_SESSION['error'])) {

			$data = array('bean_month', 'bean_day', 'bean_year', 'bean_gender');

			$form = new Form("post", $data);

			if($form->check()) {
				$form->produce(); 

				$_SESSION['register']['gender'] = $form->field->bean_gender;
			} else {
				Session::setOwn('error', 'fields');
				Router::sendTo('quickregister/start');
			}
		}
		
		$this->load_view("register/continue");

		if(isset($_SESSION['error'])) {
			$this->view->data->error = $_SESSION['error'];

			unset($_SESSION['error']);
		}

		$this->view->publish();

	}

	public function step3() {
		if(Session::isAuthed()) { Router::sendTo('me'); }

		$form = new Form("post", array('bean_username', 'bean_email', 'bean_password'));

		if($form->check()) {
			$form->produce();

			if(isset($_POST['bean_termsOfServiceSelection'])) {
				if(!$_POST['bean_termsOfServiceSelection']) {
					Session::setOwn('error', 'tos');
					Router::sendTo('quickregister/step2');
				}
			} else {
				Session::setOwn('error', 'fields');
				Router::sendTo('quickregister/step2');
			}

			$username = $form->field->bean_username;
			$password = password($form->field->bean_password);
			$email = $form->field->bean_email;

			if(!valid_email($email)) {
				Session::setOwn('error', 'email');
				Router::sendTo('quickregister/step2');
			}

			if(!preg_match('/^[a-zA-Z0-9_]+$/',$username)) {
				Session::setOwn('error', 'invalid_username');
				Router::sendTo('quickregister/step2');
			}

			if(strlen($username) < 3) {
				Session::setOwn('error', 'small_username');
				Router::sendTo('quickregister/step2');
			}

			if(strlen($form->field->bean_password) < 6) {
				Session::setOwn('error', 'small_password');
				Router::sendTo('quickregister/step2');
			}


			if(UserDao::exists('username', $username)) {
				Session::setOwn('error', 'username');
				Router::sendTo('quickregister/step2');
			}

			if(UserDao::exists('mail', $email)) {
				Session::setOwn('error', 'email_inuse');
				Router::sendTo('quickregister/step2');
			}

			$id = UserDao::create($form);

			Session::set($id);

			unset($_SESSION['register']);
			Router::sendTo('me');

		} else {
			Session::setOwn('error', 'fields');
			Router::sendTo('quickregister/step2');
		}
	}
}